// FileWriter.h: CFileWriter NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSSELECTDUMP_H_)
#define _TSSELECTDUMP_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BonTsEngine/IMediaDecoder.h"
#include "BonTsEngine/TsStream.h"
#include "BonTsEngine/TsTable.h"
#include <time.h>
#include <vector>

using std::vector;

/////////////////////////////////////////////////////////////////////////////
// ėpt@Co(CMediaDatâ܂܃t@Cɏo)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CMediaData		݃f[^
/////////////////////////////////////////////////////////////////////////////
typedef struct tagTsStatus {

	int           pid;
	int           last_continuity_counter;

	__int64       total;
	__int64       drop;
	__int64       scrambling;
	__int64       biterror;

	unsigned char last_packet[188];
	int           duplicate_count;

	tagTsStatus() {
		memset(this,0,sizeof(TS_STATUS));
	}
} TS_STATUS;

typedef struct {
	int           sync;
	int           transport_error_indicator;
	int           payload_unit_start_indicator;
	int           transport_priority;
	int           pid;
	int           transport_scrambling_control;
	int           adaptation_field_control;
	int           continuity_counter;
} TS_HEADER;

typedef struct {

	int           adaptation_field_length;
	
	int           discontinuity_counter;
	int           random_access_indicator;
	int           elementary_stream_priority_indicator;
	int           pcr_flag;
	int           opcr_flag;
	int           splicing_point_flag;
	int           transport_private_data_flag;
	int           adaptation_field_extension_flag;

	__int64       program_clock_reference;
	__int64       original_program_clock_reference;

	int           splice_countdown;

	int           transport_private_data_length;
	
	int           adaptation_field_extension_length;
	int           ltw_flag;
	int           piecewise_rate_flag;
	int           seamless_splice_flag;
	int           ltw_valid_flag;
	int           ltw_offset;
	int           piecewise_rate;
	int           splice_type;
	__int64       dts_next_au;
	
} ADAPTATION_FIELD;

typedef struct tagDumpData {
	__int64		drop;
	__int64		scrambling;
	__int64		biterror;
	time_t		stime;
	time_t		etime;
	tagDumpData() {
		memset(this,0,sizeof(DUMP_DATA));
	}
} DUMP_DATA;

class CTsSelectDump : public IMediaDecoder  
{
public:
	CTsSelectDump();
	virtual ~CTsSelectDump();

// IMediaDecoder
	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0);

	__int64 GetTotal(int pid);
	__int64 GetDrop(int pid);
	__int64 GetScrambling(int pid);
	__int64 GetBiterror(int pid);

	int GetDumpCount();
	time_t GetDumpSTime(int cnt);
	time_t GetDumpETime(int cnt);
	__int64 GetDumpDrop(int cnt);
	__int64 GetDumpScrambling(int cnt);
	__int64 GetDumpBiterror(int cnt);

protected:
	TS_STATUS stat[8192];
	__int64 drop,scrambling,biterror;
	__int64 spotdrop,spotscrambling,spotbiterror;
	__int64 lastdrop,lastscrambling,lastbiterror;
	time_t lastTime;
	vector<DUMP_DATA>	dumpList;

	void extract_ts_header(TS_HEADER *dst, unsigned char *packet);
	void extract_adaptation_field(ADAPTATION_FIELD *dst, unsigned char *data);
};

#endif // !defined(_TSSELECTDUMP_H_)
